/***********************************************************

 * Copyright (c) 2005 - Rogue Sheep Incorporated

 * All Rights Reserved

 *

 * Description:

 *

 * An InDesign CS JavaScript

 *

 * Exports all stories in an InDesign document in a specified text format.

 *

 *

 *  InDesign : CS 1.0 (v3.x) or CS 2.0 (v4.0)

 * 

 ***********************************************************/



if(app.documents.length != 0){

	if (app.activeDocument.stories.length != 0){

		with(myDialog = app.dialogs.add({name:"ExportAllStories"})){

			//Add a dialog column.

			myDialogColumn = dialogColumns.add()	

			with(myDialogColumn){

				with(borderPanels.add()){

					staticTexts.add({staticLabel:"Export as:"});

					with(myExportFormatButtons = radiobuttonGroups.add()){

						radiobuttonControls.add({staticLabel:"Text Only", checkedState:true});

						radiobuttonControls.add({staticLabel:"RTF"});

						radiobuttonControls.add({staticLabel:"InDesign Tagged Text"});

					}

				}

			}

			myReturn = myDialog.show();

			if (myReturn == true){

				//Get the values from the dialog box.

				myExportFormat = myExportFormatButtons.selectedButton;

				myDialog.destroy;

				myFolder= Folder.selectDialog ("Choose a Folder");

				if((myFolder != null)&&(app.activeDocument.stories.length !=0)){

					myExportAllStories(myExportFormat, myFolder);

				}

			}

			myDialog.destroy();

		}

	}

	else{

		alert("The document does not contain any text. Please open a document containing text and try again.");

	}

}

else{

	alert("No documents are open. Please open a document and try again.");

}

//myExportStories function takes care of exporting the stories.

//myExportFormat is a number from 0-2, where 0 = text only, 1 = rtf, and 3 = tagged text.

//myFolder is a reference to the folder in which you want to save your files.

function myExportAllStories(myExportFormat, myFolder){

	for(myCounter = 0; myCounter < app.activeDocument.stories.length; myCounter++){

		myStory = app.activeDocument.stories.item(myCounter);

		myID = myStory.id;

		switch(myExportFormat){

			case 0:

				myFormat = ExportFormat.textType;

				myExtension = ".txt"

				break;

			case 1:

				myFormat = ExportFormat.RTF;

				myExtension = ".rtf"

				break;

			case 2:

				myFormat = ExportFormat.taggedText;

				myExtension = ".txt"

				break;

		}

		myLink = myStory.itemLink;



		if ( myLink != null )

		{

			myLinkName = myLink.name;

		}

		else

		{

			myLinkName = "NotLinkedStory";

		}



		myFileName = "StoryID" + myID + "_" + myLinkName + "_" + myExtension;

		myFilePath = myFolder + "/" + myFileName;

		myFile = new File(myFilePath);

		myStory.exportFile(myFormat, myFile);

	}

}